/* ip3_auto_addr_sup.h: Header file for IP version 3 auto-addressing scheme. */

/*	IP auto-addressing functions.	*/
void				ip3_interface_connectivity (Objid module_id, int ip_address_index, int *iface_attachment, int *dest_subnet_id);
IpT_Address			ip3_next_address_create (IpT_Address_Class addr_class, int curr_addr, Boolean net_addr_inc, Boolean host_addr_inc, Boolean snet_addressing);
IpT_Address			ip3_next_classA_address_create (int curr_addr, Boolean net_addr_inc, Boolean host_addr_inc, Boolean default_address, Boolean snet_addressing);
IpT_Address			ip3_next_classB_address_create (int curr_addr, Boolean net_addr_inc, Boolean host_addr_inc, Boolean default_address, Boolean snet_addressing);
IpT_Address			ip3_next_classC_address_create (int curr_addr, Boolean net_addr_inc, Boolean host_addr_inc, Boolean default_address, Boolean snet_addressing);
void				ip3_subnet_address_assign (List *address_list);
void				ip3_auto_addr_error (char *msg1, char *msg2, char *msg3);
IpT_Address			ip3_known_gateway_iface_any (IpT_Address address, IpT_Address subnet_mask);


/* Special address representing a request for auto-addressing. This 	*/
/* special value is also defined symbolically by the IP process models 	*/
/* and 	the two must be kept consistent. 								*/
#define IPC_AUTO_ADDRESS	"0.0.0.0"



