/* ospf_error.ex.c: External code for OSPF error handling */

#include <opnet.h>
#include "ospf_error.h"

/***** Procedure Definitions *****/
void
ospf_fatal_error (char *msg)
	{
	/** Abort the simulation with the given message. **/
	FIN (ospf_fatal_error (msg));

	op_sim_end ("OSPF Error:", msg, OPC_NIL, OPC_NIL);

	FOUT;
	}

void
ospf_warn_error (char *msg)
	{
	/** Issue an warning (used for potentially inconsistent situations). **/
	FIN (ospf_warn_error (msg));

	if (op_prg_odb_ltrace_active ("ospf_warning"))
		op_prg_odb_print_minor ("OSPF Warning:", msg, OPC_NIL);

	FOUT;
	}
